Index: webkitgtk-2.46.6/Source/cmake/OptionsGTK.cmake
===================================================================
--- webkitgtk-2.46.6.orig/Source/cmake/OptionsGTK.cmake
+++ webkitgtk-2.46.6/Source/cmake/OptionsGTK.cmake
@@ -8,8 +8,7 @@ SET_PROJECT_VERSION(2 46 6)
 set(USER_AGENT_BRANDING "" CACHE STRING "Branding to add to user agent string")
 
 find_package(Cairo 1.15.2 REQUIRED)
-find_package(LibGcrypt 1.7.0 REQUIRED)
-find_package(Libtasn1 REQUIRED)
+find_package(LibGcrypt 1.6.0 REQUIRED)
 find_package(HarfBuzz 1.4.2 REQUIRED COMPONENTS ICU)
 find_package(ICU 52.1 REQUIRED COMPONENTS data i18n uc)
 find_package(JPEG REQUIRED)
@@ -108,6 +107,7 @@ WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_
 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_PDFJS PUBLIC ON)
 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SPELLCHECK PUBLIC ON)
 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_TOUCH_EVENTS PUBLIC ON)
+WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEB_CRYPTO PUBLIC ON)
 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEBDRIVER PUBLIC ON)
 
 WEBKIT_OPTION_DEFAULT_PORT_VALUE(USE_AVIF PUBLIC ON)
@@ -325,6 +325,16 @@ if (ENABLE_DOCUMENTATION AND NOT GIDocge
     message(FATAL_ERROR "ENABLE_DOCUMENTATION is needed for gi-docgen.")
 endif ()
 
+if (ENABLE_WEB_CRYPTO)
+    find_package(Libtasn1 REQUIRED)
+    if (NOT LIBTASN1_FOUND)
+        message(FATAL_ERROR "libtasn1 is required to enable Web Crypto API support.")
+    endif ()
+    if (LibGcrypt_VERSION VERSION_LESS 1.7.0)
+        message(FATAL_ERROR "libgcrypt 1.7.0 is required to enable Web Crypto API support.")
+    endif ()
+endif ()
+
 if (ENABLE_WEBDRIVER)
     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_KEYBOARD_INTERACTIONS ON)
     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_MOUSE_INTERACTIONS ON)
Index: webkitgtk-2.46.6/Source/cmake/WebKitFeatures.cmake
===================================================================
--- webkitgtk-2.46.6.orig/Source/cmake/WebKitFeatures.cmake
+++ webkitgtk-2.46.6/Source/cmake/WebKitFeatures.cmake
@@ -258,6 +258,7 @@ macro(WEBKIT_OPTION_BEGIN)
     WEBKIT_OPTION_DEFINE(ENABLE_WEB_AUDIO "Toggle Web Audio support" PRIVATE ON)
     WEBKIT_OPTION_DEFINE(ENABLE_WEB_AUTHN "Toggle Web AuthN support" PRIVATE OFF)
     WEBKIT_OPTION_DEFINE(ENABLE_WEB_CODECS "Toggle WebCodecs support" PRIVATE OFF)
+    WEBKIT_OPTION_DEFINE(ENABLE_WEB_CRYPTO "Toggle WebCrypto Subtle-Crypto support" PRIVATE ON)
     WEBKIT_OPTION_DEFINE(ENABLE_WEB_RTC "Toggle WebRTC support" PRIVATE OFF)
     WEBKIT_OPTION_DEFINE(ENABLE_WIRELESS_PLAYBACK_TARGET "Toggle wireless playback target support" PRIVATE OFF)
     WEBKIT_OPTION_DEFINE(ENABLE_XSLT "Toggle XSLT support" PRIVATE ON)
Index: webkitgtk-2.46.6/Source/WebCore/bindings/js/SerializedScriptValue.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/bindings/js/SerializedScriptValue.cpp
+++ webkitgtk-2.46.6/Source/WebCore/bindings/js/SerializedScriptValue.cpp
@@ -200,7 +200,9 @@ enum SerializationTag {
     MapObjectTag = 30,
     NonMapPropertiesTag = 31,
     NonSetPropertiesTag = 32,
+#if ENABLE(WEB_CRYPTO)
     CryptoKeyTag = 33,
+#endif
     SharedArrayBufferTag = 34,
 #if ENABLE(WEBASSEMBLY)
     WasmModuleTag = 35,
@@ -303,7 +305,9 @@ static ASCIILiteral name(SerializationTa
     case MapObjectTag: return "MapObjectTag"_s;
     case NonMapPropertiesTag: return "NonMapPropertiesTag"_s;
     case NonSetPropertiesTag: return "NonSetPropertiesTag"_s;
+#if ENABLE(WEB_CRYPTO)
     case CryptoKeyTag: return "CryptoKeyTag"_s;
+#endif
     case SharedArrayBufferTag: return "SharedArrayBufferTag"_s;
 #if ENABLE(WEBASSEMBLY)
     case WasmModuleTag: return "WasmModuleTag"_s;
@@ -461,7 +465,9 @@ static bool isTypeExposedToGlobalObject(
     case FileListTag:
     case ImageDataTag:
     case BlobTag:
+#if ENABLE(WEB_CRYPTO)
     case CryptoKeyTag:
+#endif
     case DOMPointReadOnlyTag:
     case DOMPointTag:
     case DOMRectReadOnlyTag:
@@ -622,6 +628,8 @@ static String agentClusterIDFromGlobalOb
 }
 #endif
 
+#if ENABLE(WEB_CRYPTO)
+
 const uint32_t currentKeyFormatVersion = 1;
 
 enum class CryptoKeyClassSubtag {
@@ -694,6 +702,8 @@ enum class CryptoKeyOKPOpNameTag {
     ED25519 = 1,
 };
 const uint8_t cryptoKeyOKPOpNameTagMaximumValue = 1;
+#endif
+
 static constexpr unsigned CurrentMajorVersion = 15;
 static constexpr unsigned CurrentMinorVersion = 0;
 static constexpr unsigned majorVersionFor(unsigned version) { return version & 0x00FFFFFF; }
@@ -963,6 +973,7 @@ protected:
     StackCheck m_stackCheck;
 };
 
+#if ENABLE(WEB_CRYPTO)
 static std::optional<Vector<uint8_t>> wrapCryptoKey(JSGlobalObject* lexicalGlobalObject, const Vector<uint8_t>& key)
 {
     auto context = executionContext(lexicalGlobalObject);
@@ -980,6 +991,7 @@ static std::optional<Vector<uint8_t>> un
 
     return context->unwrapCryptoKey(wrappedKey);
 }
+#endif
 
 #if ASSUME_LITTLE_ENDIAN
 template <typename T> static void writeLittleEndian(Vector<uint8_t>& buffer, T value)
@@ -2013,6 +2025,7 @@ private:
                 addToObjectPool<ArrayBufferViewTag>(obj);
                 return success;
             }
+#if ENABLE(WEB_CRYPTO)
             if (auto* key = JSCryptoKey::toWrapped(vm, obj)) {
                 write(CryptoKeyTag);
                 Vector<uint8_t> serializedKey;
@@ -2074,6 +2087,7 @@ private:
                 write(*wrappedKey);
                 return true;
             }
+#endif
 #if ENABLE(WEB_RTC)
             if (auto* rtcCertificate = JSRTCCertificate::toWrapped(vm, obj)) {
                 write(RTCCertificateTag);
@@ -2221,6 +2235,7 @@ private:
         writeLittleEndian<uint8_t>(m_buffer, static_cast<uint8_t>(tag));
     }
 
+#if ENABLE(WEB_CRYPTO)
     void write(CryptoKeyClassSubtag tag)
     {
         writeLittleEndian<uint8_t>(m_buffer, static_cast<uint8_t>(tag));
@@ -2245,6 +2260,7 @@ private:
     {
         writeLittleEndian<uint8_t>(m_buffer, static_cast<uint8_t>(tag));
     }
+#endif
 
     void write(bool b)
     {
@@ -2460,6 +2476,7 @@ private:
         write(DestinationColorSpaceSRGBTag);
     }
 
+#if ENABLE(WEB_CRYPTO)
     void write(CryptoKeyOKP::NamedCurve curve)
     {
         switch (curve) {
@@ -2664,11 +2681,14 @@ private:
             break;
         }
     }
+#endif
 
+#if ENABLE(WEB_CRYPTO)
     UseCryptoKit isUsingCryptoKit()
     {
         return executionContext(m_lexicalGlobalObject)->settingsValues().cryptoKitEnabled ? UseCryptoKit::Yes : UseCryptoKit::No;
     }
+#endif
 
     void write(std::span<const uint8_t> data)
     {
@@ -3318,10 +3338,12 @@ private:
 
     enum class VisitNamedMemberResult : uint8_t { Error, Break, Start, Unknown };
 
+#if ENABLE(WEB_CRYPTO)
     UseCryptoKit isUsingCryptoKit()
     {
         return executionContext(m_lexicalGlobalObject)->settingsValues().cryptoKitEnabled ? UseCryptoKit::Yes : UseCryptoKit::No;
     }
+#endif
 
     template<WalkerState endState>
     ALWAYS_INLINE VisitNamedMemberResult startVisitNamedMember(MarkedVector<JSObject*, 32>& outputObjectStack, Vector<Identifier, 16>& propertyNameStack, Vector<WalkerState, 16>& stateStack, JSValue& outValue)
@@ -3950,6 +3972,7 @@ private:
         return false;
     }
 
+#if ENABLE(WEB_CRYPTO)
     bool read(CryptoKeyOKP::NamedCurve& result)
     {
         uint8_t nameTag;
@@ -4321,6 +4344,7 @@ private:
         cryptoKey = getJSValue(result.get());
         return true;
     }
+#endif
 
     bool read(SerializableErrorType& errorType)
     {
@@ -5292,6 +5316,7 @@ private:
             addToObjectPool<ArrayBufferViewTag>(arrayBufferView);
             return arrayBufferView;
         }
+#if ENABLE(WEB_CRYPTO)
         case CryptoKeyTag: {
             Vector<uint8_t> wrappedKey;
             if (!read(wrappedKey)) {
@@ -5316,6 +5341,7 @@ private:
             }
             return cryptoKey;
         }
+#endif
         case DOMPointReadOnlyTag:
             return readDOMPoint<DOMPointReadOnly>();
         case DOMPointTag:
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmAESCBC.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmAesCbcCfbParams.h"
 #include "CryptoAlgorithmAesKeyParams.h"
 #include "CryptoKeyAES.h"
@@ -193,3 +195,5 @@ ExceptionOr<size_t> CryptoAlgorithmAESCB
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCBC.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmAesCbcCfbParams;
@@ -57,3 +59,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmAESCFB.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmAesCbcCfbParams.h"
 #include "CryptoAlgorithmAesKeyParams.h"
 #include "CryptoKeyAES.h"
@@ -193,3 +195,5 @@ ExceptionOr<size_t> CryptoAlgorithmAESCF
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCFB.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmAesCbcCfbParams;
@@ -54,3 +56,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.cpp
@@ -27,6 +27,8 @@
 #include "config.h"
 #include "CryptoAlgorithmAESCTR.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmAesCtrParams.h"
 #include "CryptoAlgorithmAesKeyParams.h"
 #include "CryptoKeyAES.h"
@@ -314,3 +316,5 @@ auto CryptoAlgorithmAESCTR::CounterBlock
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESCTR.h
@@ -28,6 +28,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmAesCtrParams;
@@ -82,3 +84,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmAESGCM.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmAesGcmParams.h"
 #include "CryptoAlgorithmAesKeyParams.h"
 #include "CryptoKeyAES.h"
@@ -242,3 +244,5 @@ ExceptionOr<size_t> CryptoAlgorithmAESGC
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESGCM.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmAesGcmParams;
@@ -55,3 +57,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmAESKW.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmAesKeyParams.h"
 #include "CryptoKeyAES.h"
 #include <variant>
@@ -182,3 +184,5 @@ ExceptionOr<size_t> CryptoAlgorithmAESKW
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmAESKW.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoKeyAES;
@@ -54,3 +56,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmECDH.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmEcKeyParams.h"
 #include "CryptoAlgorithmEcdhKeyDeriveParams.h"
 #include "CryptoKeyEC.h"
@@ -229,3 +231,5 @@ void CryptoAlgorithmECDH::exportKey(Cryp
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDH.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoKeyEC;
@@ -51,3 +53,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmECDSA.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmEcKeyParams.h"
 #include "CryptoAlgorithmEcdsaParams.h"
 #include "CryptoKeyEC.h"
@@ -218,3 +220,5 @@ void CryptoAlgorithmECDSA::exportKey(Cry
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmECDSA.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmEcdsaParams;
@@ -53,3 +55,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmEd25519.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoKeyOKP.h"
 #include "NotImplemented.h"
 #include "ScriptExecutionContext.h"
@@ -196,3 +198,4 @@ void CryptoAlgorithmEd25519::exportKey(C
 }
 
 } // namespace WebCore
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmEd25519.h
@@ -26,6 +26,7 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
 namespace WebCore {
 
 constexpr auto ed25519KeySize = 32;
@@ -59,3 +60,5 @@ inline CryptoAlgorithmIdentifier CryptoA
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmHKDF.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmHkdfParams.h"
 #include "CryptoKeyRaw.h"
 #include "ScriptExecutionContext.h"
@@ -82,3 +84,5 @@ ExceptionOr<size_t> CryptoAlgorithmHKDF:
 }
     
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHKDF.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmHkdfParams;
@@ -50,3 +52,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmHMAC.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmHmacKeyParams.h"
 #include "CryptoKeyHMAC.h"
 #include "ScriptExecutionContext.h"
@@ -198,4 +200,6 @@ ExceptionOr<size_t> CryptoAlgorithmHMAC:
     return CryptoKeyHMAC::getKeyLength(parameters);
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmHMAC.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoKeyHMAC;
@@ -54,3 +56,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmPBKDF2.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmPbkdf2Params.h"
 #include "CryptoKeyRaw.h"
 #include <JavaScriptCore/JSCJSValueInlines.h>
@@ -80,3 +82,5 @@ ExceptionOr<size_t> CryptoAlgorithmPBKDF
 }
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmPBKDF2.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmPbkdf2Params;
@@ -50,3 +52,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmRSAES_PKCS1_v1_5.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmRsaKeyGenParams.h"
 #include "CryptoKeyPair.h"
 #include "CryptoKeyRSA.h"
@@ -184,4 +186,6 @@ void CryptoAlgorithmRSAES_PKCS1_v1_5::ex
     callback(format, WTFMove(result));
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSAES_PKCS1_v1_5.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoKeyRSA;
@@ -52,3 +54,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmRSA_OAEP.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmRsaHashedImportParams.h"
 #include "CryptoAlgorithmRsaHashedKeyGenParams.h"
 #include "CryptoAlgorithmRsaOaepParams.h"
@@ -254,4 +256,6 @@ void CryptoAlgorithmRSA_OAEP::exportKey(
     callback(format, WTFMove(result));
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_OAEP.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmRsaOaepParams;
@@ -53,3 +55,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.cpp
@@ -26,7 +26,7 @@
 #include "config.h"
 #include "CryptoAlgorithmRSA_PSS.h"
 
-#if HAVE(RSA_PSS)
+#if ENABLE(WEB_CRYPTO) && HAVE(RSA_PSS)
 
 #include "CryptoAlgorithmRsaHashedImportParams.h"
 #include "CryptoAlgorithmRsaHashedKeyGenParams.h"
@@ -244,4 +244,4 @@ void CryptoAlgorithmRSA_PSS::exportKey(C
 
 }
 
-#endif // HAVE(RSA_PSS)
+#endif // ENABLE(WEB_CRYPTO) && HAVE(RSA_PSS)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSA_PSS.h
@@ -27,7 +27,7 @@
 
 #include "CryptoAlgorithm.h"
 
-#if HAVE(RSA_PSS)
+#if ENABLE(WEB_CRYPTO) && HAVE(RSA_PSS)
 
 namespace WebCore {
 
@@ -56,4 +56,4 @@ private:
 
 } // namespace WebCore
 
-#endif // HAVE(RSA_PSS)
+#endif // ENABLE(WEB_CRYPTO) && HAVE(RSA_PSS)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmRSASSA_PKCS1_v1_5.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "CryptoAlgorithmRsaHashedImportParams.h"
 #include "CryptoAlgorithmRsaHashedKeyGenParams.h"
 #include "CryptoKeyPair.h"
@@ -238,4 +240,6 @@ void CryptoAlgorithmRSASSA_PKCS1_v1_5::e
     callback(format, WTFMove(result));
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmRSASSA_PKCS1_v1_5.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoKeyRSA;
@@ -52,3 +54,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmSHA1.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ScriptExecutionContext.h"
 #include <pal/crypto/CryptoDigest.h>
 
@@ -46,4 +48,6 @@ void CryptoAlgorithmSHA1::digest(Vector<
     CryptoAlgorithm::dispatchDigest(workQueue, context, WTFMove(callback), WTFMove(exceptionCallback), WTFMove(message), PAL::CryptoDigest::Algorithm::SHA_1);
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA1.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmSHA1 final : public CryptoAlgorithm {
@@ -42,3 +44,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmSHA224.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ScriptExecutionContext.h"
 #include <pal/crypto/CryptoDigest.h>
 
@@ -58,4 +60,6 @@ void CryptoAlgorithmSHA224::digest(Vecto
     });
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA224.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmSHA224 final : public CryptoAlgorithm {
@@ -42,3 +44,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmSHA256.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ScriptExecutionContext.h"
 #include <pal/crypto/CryptoDigest.h>
 
@@ -46,4 +48,6 @@ void CryptoAlgorithmSHA256::digest(Vecto
     CryptoAlgorithm::dispatchDigest(workQueue, context, WTFMove(callback), WTFMove(exceptionCallback), WTFMove(message), PAL::CryptoDigest::Algorithm::SHA_256);
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA256.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmSHA256 final : public CryptoAlgorithm {
@@ -42,3 +44,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "CryptoAlgorithmSHA384.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ScriptExecutionContext.h"
 #include <pal/crypto/CryptoDigest.h>
 
@@ -46,4 +48,6 @@ void CryptoAlgorithmSHA384::digest(Vecto
     CryptoAlgorithm::dispatchDigest(workQueue, context, WTFMove(callback), WTFMove(exceptionCallback), WTFMove(message), PAL::CryptoDigest::Algorithm::SHA_384);
 }
 
-} // namespace WebCore
+}
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/algorithms/CryptoAlgorithmSHA384.h
@@ -27,6 +27,8 @@
 
 #include "CryptoAlgorithm.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 class CryptoAlgorithmSHA384 final : public CryptoAlgorithm {
@@ -42,3 +44,5 @@ private:
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
